"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isOverrideStyleArray = exports.isButtonTypeKey = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Text_1 = __importDefault(require("../Text/Text"));
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const themeHelper_1 = require("../UikitUtils/themeHelper");
const ButtonHelper_1 = require("./ButtonHelper");
const buttonStyles_1 = require("./buttonStyles");
const isButtonTypeKey = (str) => str !== undefined;
exports.isButtonTypeKey = isButtonTypeKey;
const isOverrideStyleArray = (str) => str !== undefined;
exports.isOverrideStyleArray = isOverrideStyleArray;
const defaultProps = {
    type: 'primary',
    textSize: 16,
};
const Button = ({ flat, overrideStyle, onClick, children, curved, disabled, flex, testID, loading, contain, textSize, type, }) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.default);
    const ref = (0, react_1.useRef)(null);
    let styleArray = [buttonStyles_1.styles.common];
    const textColor = (0, ButtonHelper_1.getTextColors)({
        type,
        theme,
        disabled,
    });
    (0, ButtonHelper_1.buttonColorHelper)({
        styleArray,
        theme,
        type,
    });
    (0, ButtonHelper_1.buttonHelper)(styleArray, flex, curved, flat, disabled, theme, type, contain);
    if (overrideStyle) {
        if ((0, exports.isOverrideStyleArray)(overrideStyle) && Array.isArray(overrideStyle)) {
            styleArray = [...styleArray, ...overrideStyle];
        }
        else {
            styleArray.push(overrideStyle);
        }
    }
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { ref: ref, disabled: disabled || loading, onPress: onClick, style: styleArray, testID: testID },
        react_1.default.createElement(react_native_1.View, { style: buttonStyles_1.styles.indicatorDirection },
            loading && (react_1.default.createElement(react_native_1.ActivityIndicator, { size: "small", color: (0, themeHelper_1.primaryColor)(theme), style: buttonStyles_1.styles.indicator })),
            typeof children === 'string' || typeof children === 'number' ? (react_1.default.createElement(Text_1.default, { bold: true, size: textSize, color: textColor }, children)) : (children))));
};
Button.defaultProps = defaultProps;
exports.default = Button;
