"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MONTH = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Text_1 = __importDefault(require("../Text/Text"));
exports.MONTH = [
    'January',
    'February',
    'March',
    'April',
    'May',
    'June',
    'July',
    'August',
    'September',
    'October',
    'November',
    'December',
];
const styles = react_native_1.StyleSheet.create({
    header: {
        flexDirection: 'row',
        justifyContent: 'space-around',
    },
    year: {
        marginLeft: 8,
    },
});
const CalendarHeader = ({ date, handleOpenMonth, handleOpenYear }) => {
    const year = `${date.getFullYear()}`;
    const monthIndex = date.getMonth();
    const month = exports.MONTH[monthIndex];
    return (react_1.default.createElement(react_native_1.View, { style: styles.header },
        react_1.default.createElement(react_native_1.TouchableOpacity, { testID: "handleOpenMonth", onPress: handleOpenMonth },
            react_1.default.createElement(Text_1.default, null, month)),
        react_1.default.createElement(react_native_1.TouchableOpacity, { testID: "handleOpenYear", style: styles.year, onPress: handleOpenYear },
            react_1.default.createElement(Text_1.default, { testID: "yearText" }, year))));
};
exports.default = CalendarHeader;
