"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useClickOutsideWeb = void 0;
/* eslint-env browser */
const react_1 = require("react");
const useClickOutsideWeb = ({ handleClick, }) => {
    (0, react_1.useEffect)(() => {
        if (typeof Window !== 'undefined') {
            document.addEventListener('mousedown', handleClick);
        }
        return () => {
            if (typeof Window !== 'undefined') {
                document.removeEventListener('mousedown', handleClick);
            }
        };
    }, []);
};
exports.useClickOutsideWeb = useClickOutsideWeb;
