"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Calendar_1 = require("./Calendar");
const InputText_1 = __importDefault(require("../InputText/InputText"));
const colors_1 = require("../UikitUtils/colors");
const Button_1 = __importDefault(require("../Button/Button"));
const CalendarStyle_1 = require("./CalendarStyle");
const styles = react_native_1.StyleSheet.create({
    yearContainer: {
        minWidth: 252,
        position: 'absolute',
        zIndex: 1,
        height: 220,
        backgroundColor: '#ffffff',
        borderWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        borderRadius: 4,
        justifyContent: 'center',
        alignItems: 'center',
    },
    button: {
        width: 86,
        marginTop: 24,
    },
});
const Year = ({ date, setDate, handleCloseYear, align }, ref) => {
    const yearContainerStyle = (0, react_1.useMemo)(() => {
        switch (align) {
            case 'topRight':
                return react_native_1.StyleSheet.flatten([
                    styles.yearContainer,
                    CalendarStyle_1.commonCalendarStyle.topRightYearOrMonthContainer,
                ]);
            case 'bottomLeft':
                return react_native_1.StyleSheet.flatten([
                    styles.yearContainer,
                    CalendarStyle_1.commonCalendarStyle.bottomContainer,
                ]);
            default:
                return react_native_1.StyleSheet.flatten([
                    styles.yearContainer,
                    CalendarStyle_1.commonCalendarStyle.topContainer,
                ]);
        }
    }, []);
    const year = date ? date.year : new Date().getFullYear();
    const [chosenYear, setYear] = (0, react_1.useState)(`${year}`);
    const handleTouchablePress = (e) => e.stopPropagation();
    const handleYearChange = (value) => {
        const parsedValue = parseInt(value, 10);
        if (!Number.isNaN(parsedValue) && parsedValue > 19 && parsedValue < 9999) {
            setYear(`${parsedValue}`);
        }
    };
    const handleDateUpdate = (e) => {
        const parsedValue = parseInt(chosenYear, 10);
        const partialDateObj = (0, Calendar_1.getRequiredPartialDateObj)(date);
        const dateString = (0, Calendar_1.getDateString)({ ...partialDateObj, year: parsedValue });
        const dateObject = (0, Calendar_1.convertDateStrtoDateObject)(dateString);
        setDate(dateObject);
        handleCloseYear(e);
    };
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { activeOpacity: 1, ref: ref, style: yearContainerStyle, onPress: handleTouchablePress, testID: "yearContainer" },
        react_1.default.createElement(InputText_1.default, { value: chosenYear, onChange: handleYearChange, placeholder: "Enter the year", align: "center" }),
        react_1.default.createElement(Button_1.default, { onClick: handleDateUpdate, overrideStyle: styles.button, testID: "setYearBtn" }, "Set")));
};
exports.default = react_1.default.forwardRef(Year);
