"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dateHelper = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const CalendarData_1 = require("./CalendarData");
const uikitStyles = react_native_1.StyleSheet.create({
    listItem: {
        paddingVertical: 6,
    },
    titleContainer: {
        width: 100,
    },
    columnStyle: {
        padding: 10,
    },
});
const RenderItem = ({ item, selected, selectHandler }) => {
    const color = selected === item.value ? 'theme' : 'gray';
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => selectHandler(item.value), style: uikitStyles.listItem },
        react_1.default.createElement(Flex_1.default, { center: true, overrideStyle: uikitStyles.titleContainer },
            react_1.default.createElement(Text_1.default, { color: color, bold: selected === item.value }, item.label))));
};
const FlatListGenerator = ({ dataSource, selectHandler, selected, numColumns, }) => {
    const columnWrapperStyle = !!numColumns && uikitStyles.columnStyle;
    return (react_1.default.createElement(react_native_1.FlatList, { showsVerticalScrollIndicator: false, data: dataSource, renderItem: ({ item }) => (react_1.default.createElement(RenderItem, { item: item, selected: selected, selectHandler: selectHandler })), keyExtractor: (item) => item.label, numColumns: numColumns, columnWrapperStyle: columnWrapperStyle }));
};
exports.default = FlatListGenerator;
const dateHelper = (date, month, year) => {
    const currDate = new Date(date);
    currDate.setMonth(month - 1);
    currDate.setFullYear(year);
    return (0, CalendarData_1.getDateString)(currDate);
};
exports.dateHelper = dateHelper;
