"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_calendars_1 = require("react-native-calendars");
const react_native_1 = require("react-native");
const CalendarHeader_1 = __importDefault(require("../Calendar/CalendarHeader"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Modal_1 = __importDefault(require("../Modal/Modal"));
const CalendarData_1 = require("./CalendarData");
const CalendarHelpers_1 = require("./CalendarHelpers");
const SvgChevronLeft_1 = __importDefault(require("../icons/SvgChevronLeft"));
const SvgChevronRight_1 = __importDefault(require("../icons/SvgChevronRight"));
const Button_1 = __importDefault(require("../Button/Button"));
const colors_1 = require("../UikitUtils/colors");
const MonthList_1 = __importDefault(require("./MonthList"));
const YearList_1 = __importDefault(require("./YearList"));
// const screenWidth = Dimensions.get('window').width;
const uikitStyles = react_native_1.StyleSheet.create({
    overAll: {
    // height: '100%',
    // width: screenWidth,
    },
    calendar: {
        borderTopLeftRadius: 10,
        borderTopRightRadius: 10,
        borderBottomWidth: 0,
    },
    BtnContainer: {
        backgroundColor: colors_1.WHITE,
        paddingHorizontal: 16,
        paddingTop: 34,
        paddingBottom: 6,
    },
    divider: {
        width: 16,
    },
});
const renderArrow = (direction) => {
    if (direction === 'right') {
        return react_1.default.createElement(SvgChevronRight_1.default, null);
    }
    return react_1.default.createElement(SvgChevronLeft_1.default, null);
};
const CalendarNative = ({ open, onClose, primaryButtonName, secondarButtonName, onConfirm, }) => {
    const [date, setDate] = (0, react_1.useState)(CalendarData_1.dateString);
    const [month, setMonth] = (0, react_1.useState)(CalendarData_1.currentMonth + 1);
    const [year, setYear] = (0, react_1.useState)(CalendarData_1.currentYear);
    const [openYear, setOpenYear] = (0, react_1.useState)(false);
    const [openMonth, setOpenMonth] = (0, react_1.useState)(false);
    const newDate = (0, react_1.useMemo)(() => (0, CalendarHelpers_1.dateHelper)(date, month, year), [
        date,
        month,
        year,
    ]);
    const handleConfirm = () => {
        onConfirm(date);
        onClose();
    };
    const handleDate = (day) => {
        setDate(day.dateString);
    };
    return (react_1.default.createElement(Modal_1.default, { animationIn: 'fadeIn', animationOut: 'fadeOut', isVisible: open, onBackdropPress: onClose },
        openMonth && (react_1.default.createElement(MonthList_1.default, { closeHandler: () => setOpenMonth(false), getMonth: setMonth, selectedMonth: month })),
        openYear && (react_1.default.createElement(YearList_1.default, { closeHandler: () => setOpenYear(false), getYear: setYear, selectedYear: year })),
        react_1.default.createElement(Flex_1.default, { overrideStyle: uikitStyles.overAll },
            !openMonth && !openYear && (react_1.default.createElement(react_native_calendars_1.Calendar, { onDayPress: handleDate, onMonthChange: curMon => {
                    setMonth(curMon.month);
                }, maxDate: new Date().toDateString(), current: newDate, markedDates: {
                    [date]: {
                        selected: true,
                        selectedColor: colors_1.SEMANTIC_INFO_BLUE_PRIMARY,
                    },
                }, monthFormat: "yyyy mm", renderHeader: currDate => (react_1.default.createElement(CalendarHeader_1.default, { date: currDate, handleOpenMonth: () => setOpenMonth(true), handleOpenYear: () => setOpenYear(true) })), style: uikitStyles.calendar, renderArrow: direction => renderArrow(direction) })),
            !openMonth && !openYear && (react_1.default.createElement(Flex_1.default, { row: true, overrideStyle: uikitStyles.BtnContainer },
                react_1.default.createElement(Flex_1.default, { flex: 1 },
                    react_1.default.createElement(Button_1.default, { type: "secondary", onClick: onClose }, secondarButtonName)),
                react_1.default.createElement(react_native_1.View, { style: uikitStyles.divider }),
                react_1.default.createElement(Flex_1.default, { flex: 1 },
                    react_1.default.createElement(Button_1.default, { onClick: handleConfirm }, primaryButtonName)))))));
};
exports.default = CalendarNative;
