"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Playground = exports.WithPaddingMaintained = exports.WithFlexWrapper = exports.ChipWithIcons = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_2 = require("@storybook/react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Chip_1 = __importDefault(require("./Chip"));
const Button_1 = __importDefault(require("../Button/Button"));
const Text_1 = __importDefault(require("../Text/Text"));
const InputText_1 = __importDefault(require("../InputText/InputText"));
const SvgCirclePlus_1 = __importDefault(require("../icons/SvgCirclePlus"));
const styles = react_native_1.StyleSheet.create({
    type: {
        paddingHorizontal: 24,
        paddingVertical: 16,
    },
    chipSpacing: {
        marginBottom: 10,
    },
});
const ChipWithIcons = () => {
    const [isOpen, setIsOpen] = (0, react_1.useState)(true);
    const [isOpen1, setIsOpen1] = (0, react_1.useState)(true);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Flex_1.default, { center: true },
            react_1.default.createElement(Button_1.default, { onClick: () => {
                    setIsOpen(true);
                    setIsOpen1(true);
                }, type: "secondary" }, "Show chips")),
        react_1.default.createElement(Flex_1.default, { overrideStyle: styles.type }, isOpen && (react_1.default.createElement(Chip_1.default, { message: "Type something", type: "info", onClose: () => {
                setIsOpen(false);
            } }))),
        react_1.default.createElement(Flex_1.default, { overrideStyle: styles.type }, isOpen1 && (react_1.default.createElement(Chip_1.default, { message: "Type something", type: "success", onClose: () => {
                setIsOpen1(false);
            }, icon: (height, width, fill) => (react_1.default.createElement(SvgCirclePlus_1.default, { height: height, width: width, fill: fill })) })))));
};
exports.ChipWithIcons = ChipWithIcons;
const WithFlexWrapper = () => {
    const [isRow, setIsRow] = (0, react_1.useState)(false);
    return (react_1.default.createElement(Flex_1.default, null,
        react_1.default.createElement(Flex_1.default, { center: true },
            react_1.default.createElement(Button_1.default, { onClick: () => {
                    setIsRow(!isRow);
                }, type: "secondary" },
                react_1.default.createElement(Text_1.default, { color: "theme" },
                    "flexDirection:",
                    isRow ? 'column' : 'row'))),
        react_1.default.createElement(Flex_1.default, { between: true, row: isRow },
            react_1.default.createElement(Flex_1.default, { overrideStyle: styles.chipSpacing },
                react_1.default.createElement(Chip_1.default, { message: "Type something", icon: (height, width, fill) => (react_1.default.createElement(SvgCirclePlus_1.default, { height: height, width: width, fill: fill })) })),
            react_1.default.createElement(Flex_1.default, { overrideStyle: styles.chipSpacing },
                react_1.default.createElement(Chip_1.default, { message: "Type something" })),
            react_1.default.createElement(Flex_1.default, { start: true },
                react_1.default.createElement(Button_1.default, null, "Add Reason")))));
};
exports.WithFlexWrapper = WithFlexWrapper;
const WithPaddingMaintained = () => {
    const [val, setVal] = (0, react_1.useState)('20');
    const [message, setMessage] = (0, react_1.useState)('Maintain Padding');
    return (react_1.default.createElement(Flex_1.default, null,
        react_1.default.createElement(Flex_1.default, { between: true, row: true },
            react_1.default.createElement(Flex_1.default, { overrideStyle: styles.chipSpacing },
                react_1.default.createElement(Flex_1.default, { overrideStyle: { width: Number(val) } },
                    react_1.default.createElement(Chip_1.default, { message: message, onClose: () => { } }))),
            react_1.default.createElement(Flex_1.default, { start: true, row: true },
                react_1.default.createElement(InputText_1.default, { value: val, onChange: setVal, label: "Enter Width" }),
                react_1.default.createElement(InputText_1.default, { value: message, onChange: setMessage, label: "Enter Message" })))));
};
exports.WithPaddingMaintained = WithPaddingMaintained;
exports.default = {
    title: 'Components/Chip',
    component: Chip_1.default,
};
const Template = args => (react_1.default.createElement(Flex_1.default, null,
    react_1.default.createElement(Chip_1.default, { ...args })));
exports.Playground = Template.bind({});
exports.Playground.args = {
    message: `Type something`,
};
if (typeof Window === 'undefined') {
    (0, react_native_2.storiesOf)('Chip', module)
        .add('Basic', () => react_1.default.createElement(Chip_1.default, { message: "Type something" }))
        .add('Chip with actions', () => react_1.default.createElement(exports.ChipWithIcons, null))
        .add('With Flex Wrapper', () => react_1.default.createElement(exports.WithFlexWrapper, null));
}
