"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.styles = void 0;
const react_native_1 = require("react-native");
const colors_1 = require("../UikitUtils/colors");
exports.styles = react_native_1.StyleSheet.create({
    relativestyle: {
        position: 'relative',
    },
    common: {
        fontFamily: 'lato',
        paddingHorizontal: 20,
        width: '100%',
        paddingVertical: 12,
    },
    normalCommon: {
        fontFamily: 'lato',
        paddingHorizontal: 2,
        width: '100%',
        paddingVertical: 12,
    },
    curved: {
        borderWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        borderRadius: 4,
    },
    normal: {
        borderBottomWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        paddingHorizontal: 2,
    },
    rounded: {
        borderWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        borderRadius: 40,
    },
    enableClose: {
        position: 'absolute',
        marginTop: 1,
        right: 8,
    },
    noBorder: {
        borderColor: 'transparent',
    },
    error: {
        borderColor: colors_1.SEMANTIC_RED_PRIMARY,
    },
    bold: {
        fontFamily: 'lato-bold',
    },
    action: {
        right: 8,
        justifyContent: 'center',
    },
    containerActionStyle: {
        flexDirection: 'row',
        justifyContent: 'center',
        alignItems: 'center',
    },
    inputAction: {
        flex: 1,
    },
    actionLeft: {
        left: 8,
    },
    textAlignVertical: {
        textAlignVertical: 'top',
    },
    leftAction: {
        alignSelf: 'center',
        justifyContent: 'center',
        paddingLeft: 8,
    },
    rightAction: {
        alignSelf: 'center',
        justifyContent: 'center',
    },
    disabled: {
        backgroundColor: colors_1.GRAY_95,
        borderStyle: 'dashed',
    },
    white: {
        backgroundColor: colors_1.WHITE,
    },
    errorView: {
        marginTop: 3,
    },
});
