import { TextStyle, ViewStyle } from 'react-native';
import { ThemeType } from '../UikitUtils/themeTypes';
import { InputAlign, InputTypes } from './InputText';
type inputTypeProps = {
    theme: ThemeType;
    containerStyleArray: ViewStyle[];
    type: InputTypes;
};
export declare const inputTypesHelper: ({ type, containerStyleArray, }: inputTypeProps) => void;
type inputActionProps = {
    actionLeftStyleArray: ViewStyle[];
    actionRightStyleArray: ViewStyle[];
    type: InputTypes;
    theme: ThemeType;
};
export declare const inputActionHelper: ({ actionLeftStyleArray, actionRightStyleArray, type, theme, }: inputActionProps) => void;
export declare const inputAlginHelper: (align: InputAlign, textStyleArray: ViewStyle[] | TextStyle[]) => void;
type inputHelperType = {
    theme: ThemeType;
    containerStyleArray: ViewStyle[];
    flex: number | undefined;
    error: boolean | undefined;
    overrideStyle: ViewStyle | undefined | any;
    disabled: boolean | undefined;
    white: boolean | undefined;
};
export declare const inputHelper: ({ containerStyleArray, flex, error, overrideStyle, disabled, white, }: inputHelperType) => void;
type textStyleHelperProps = {
    theme: ThemeType;
    actionRight: Function | undefined;
    actionLeft: Function | undefined;
    textStyleArray: ViewStyle[] | TextStyle[];
    bold: boolean | undefined;
    size: number;
    disabled?: boolean;
    type: InputTypes;
};
export declare const textStyleHelper: ({ actionRight, actionLeft, textStyleArray, bold, size, disabled, type, }: textStyleHelperProps) => void;
export declare const minHeights: (minHeight: number | undefined, styleArray: ViewStyle[]) => void;
export {};
