"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Playground = exports.Basic = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("@storybook/react-native");
const Modal_1 = __importDefault(require("./Modal"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const Button_1 = __importDefault(require("../Button/Button"));
const SvgCalendar_1 = __importDefault(require("../icons/SvgCalendar"));
const TWO_BUTTONS = 'twoButtons';
const WITH_CLOSE_ICON = 'withCloseIcon';
const WITH_TITTLE_ICON = 'withTittleIcon';
const WITH_LARGE_ICON = 'withLargeIcon';
const WITH_TITTLE_AND_CLOSE_ICON = 'withTittleAndCloseIcon';
const WITH_LOADING = 'withLoading';
const Basic = () => {
    const [modalType, setShowModalType] = (0, react_1.useState)('');
    const [loading, setLoading] = (0, react_1.useState)(false);
    const confirmTitle = 'Are you sure?';
    const message = 'The Modal component is a basic way to present content above an enclosing view.';
    const confirmPrimaryAction = 'Confirm';
    const confirmSecondaryAction = 'Cancel';
    const closeModalHandler = () => setShowModalType('');
    const loadingAction = 'Load for 3s';
    const loaderHandler = () => {
        setLoading(true);
        setTimeout(() => {
            setLoading(false);
        }, 3000);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Flex_1.default, { overrideStyle: { padding: 20 } },
            react_1.default.createElement(Button_1.default, { onClick: () => setShowModalType(TWO_BUTTONS), overrideStyle: { marginBottom: 20 } }, "Modal with Primary and Secondary Button"),
            react_1.default.createElement(Modal_1.default, { key: TWO_BUTTONS, isVisible: modalType === TWO_BUTTONS, onClose: closeModalHandler, title: confirmTitle, primaryAction: confirmPrimaryAction, primaryActionHandler: closeModalHandler, secondaryAction: confirmSecondaryAction, secondaryActionHandler: closeModalHandler },
                react_1.default.createElement(Text_1.default, { size: 18 }, message)),
            react_1.default.createElement(Button_1.default, { onClick: () => setShowModalType(WITH_CLOSE_ICON), overrideStyle: { marginBottom: 20 } }, "Modal with close icon"),
            react_1.default.createElement(Modal_1.default, { key: WITH_CLOSE_ICON, showClose: true, isVisible: modalType === WITH_CLOSE_ICON, onClose: closeModalHandler, title: confirmTitle, primaryAction: confirmPrimaryAction, primaryActionHandler: closeModalHandler, secondaryAction: confirmSecondaryAction, secondaryActionHandler: closeModalHandler },
                react_1.default.createElement(Text_1.default, { size: 18 }, message)),
            react_1.default.createElement(Button_1.default, { onClick: () => setShowModalType(WITH_TITTLE_ICON), overrideStyle: { marginBottom: 20 } }, "Modal with Tittle icon"),
            react_1.default.createElement(Modal_1.default, { key: WITH_TITTLE_ICON, showIcon: (height, width) => (react_1.default.createElement(SvgCalendar_1.default, { fill: colors_1.BLACK, height: height, width: width })), isVisible: modalType === WITH_TITTLE_ICON, onClose: closeModalHandler, title: confirmTitle, primaryAction: confirmPrimaryAction, primaryActionHandler: closeModalHandler, secondaryAction: confirmSecondaryAction, secondaryActionHandler: closeModalHandler },
                react_1.default.createElement(Text_1.default, { size: 18 }, message)),
            react_1.default.createElement(Button_1.default, { onClick: () => setShowModalType(WITH_TITTLE_AND_CLOSE_ICON), overrideStyle: { marginBottom: 20 } }, "Modal with Tittle icon and Close icon"),
            react_1.default.createElement(Modal_1.default, { key: WITH_TITTLE_AND_CLOSE_ICON, showClose: true, showIcon: (height, width) => (react_1.default.createElement(SvgCalendar_1.default, { fill: colors_1.BLACK, height: height, width: width })), isVisible: modalType === WITH_TITTLE_AND_CLOSE_ICON, onClose: closeModalHandler, title: confirmTitle, primaryAction: confirmPrimaryAction, primaryActionHandler: closeModalHandler, secondaryAction: confirmSecondaryAction, secondaryActionHandler: closeModalHandler },
                react_1.default.createElement(Text_1.default, { size: 18 }, message)),
            react_1.default.createElement(Button_1.default, { onClick: () => setShowModalType(WITH_LARGE_ICON), overrideStyle: { marginBottom: 20 } }, "Modal with Large icon"),
            react_1.default.createElement(Modal_1.default, { key: WITH_LARGE_ICON, iconSize: "large", showIcon: (height, width) => (react_1.default.createElement(SvgCalendar_1.default, { fill: colors_1.BLACK, height: height, width: width })), isVisible: modalType === WITH_LARGE_ICON, onClose: closeModalHandler, title: confirmTitle, primaryAction: confirmPrimaryAction, primaryActionHandler: closeModalHandler, secondaryAction: confirmSecondaryAction, secondaryActionHandler: closeModalHandler },
                react_1.default.createElement(Text_1.default, { size: 18, align: "center" }, message)),
            react_1.default.createElement(Button_1.default, { onClick: () => setShowModalType(WITH_LOADING), overrideStyle: { marginBottom: 20 } }, "Modal with Primary Action Loading"),
            react_1.default.createElement(Modal_1.default, { key: WITH_LOADING, isVisible: modalType === WITH_LOADING, title: confirmTitle, primaryAction: loadingAction, primaryActionHandler: loaderHandler, secondaryAction: confirmSecondaryAction, secondaryActionHandler: closeModalHandler, onClose: closeModalHandler, isLoading: loading },
                react_1.default.createElement(Text_1.default, { size: 18, align: "center" }, message)))));
};
exports.Basic = Basic;
if (typeof Window === 'undefined') {
    (0, react_native_1.storiesOf)('Modal', module).add('Modal', () => react_1.default.createElement(exports.Basic, null));
}
exports.default = {
    title: 'Components/Modal',
    component: Modal_1.default,
};
const Template = args => (react_1.default.createElement(Modal_1.default, { ...args }));
exports.Playground = Template.bind({});
exports.Playground.args = {};
