"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.reversePercentage = exports.buildAnimations = exports.makeSlideTranslation = exports.initializeAnimations = void 0;
const react_native_1 = require("react-native");
const animatable = __importStar(require("react-native-animatable"));
const { height, width } = react_native_1.Dimensions.get('window');
const initializeAnimations = () => {
    // Since react-native-animatable applies by default a margin of 100 to its
    // sliding animation, we reset them here overriding the margin to 0.
    const animationDefinitions = {
        slideInDown: (0, exports.makeSlideTranslation)('translateY', -height, 0),
        slideInUp: (0, exports.makeSlideTranslation)('translateY', height, 0),
        slideInLeft: (0, exports.makeSlideTranslation)('translateX', -width, 0),
        slideInRight: (0, exports.makeSlideTranslation)('translateX', width, 0),
        slideOutDown: (0, exports.makeSlideTranslation)('translateY', 0, height),
        slideOutUp: (0, exports.makeSlideTranslation)('translateY', 0, -height),
        slideOutLeft: (0, exports.makeSlideTranslation)('translateX', 0, -width),
        slideOutRight: (0, exports.makeSlideTranslation)('translateX', 0, width),
    };
    animatable.initializeRegistryWithDefinitions(animationDefinitions);
};
exports.initializeAnimations = initializeAnimations;
const makeSlideTranslation = (translationType, fromValue, toValue) => ({
    from: {
        [translationType]: fromValue,
    },
    to: {
        [translationType]: toValue,
    },
});
exports.makeSlideTranslation = makeSlideTranslation;
// User can define custom react-native-animatable animations, see PR #72
// Utility for creating our own custom react-native-animatable animations
const buildAnimations = ({ animationIn, animationOut, }) => {
    let updatedAnimationIn;
    let updatedAnimationOut;
    if (isObject(animationIn)) {
        const animationName = JSON.stringify(animationIn);
        makeAnimation(animationName, animationIn);
        updatedAnimationIn = animationName;
    }
    else {
        updatedAnimationIn = animationIn;
    }
    if (isObject(animationOut)) {
        const animationName = JSON.stringify(animationOut);
        makeAnimation(animationName, animationOut);
        updatedAnimationOut = animationName;
    }
    else {
        updatedAnimationOut = animationOut;
    }
    return {
        animationIn: updatedAnimationIn,
        animationOut: updatedAnimationOut,
    };
};
exports.buildAnimations = buildAnimations;
const reversePercentage = (x) => -(x - 1);
exports.reversePercentage = reversePercentage;
const makeAnimation = (name, obj) => {
    animatable.registerAnimation(name, animatable.createAnimation(obj));
};
const isObject = (obj) => {
    return obj !== null && typeof obj === 'object';
};
