## List of Components
(https://native-pilot-ui.netlify.app)
## To run on the web use

```
yarn storybook
```

## To run on ios

```
yarn ios
```

## To run on android

```
yarn android
```
## Auto Update Story

```sh
yarn update-stories
```
## Installation

In your project root folder run the following command

```sh
yarn add native-pilot-ui
```

or 
```sh
npm i native-pilot-ui
```

## Usage

In your project entry point make sure you have added the theme provider

```js
import React from 'react';
import { ThemeProvider } from 'native-pilot-ui';

const Main = () => {
  return (
      <ThemeProvider theme={'app'}>
        <MainRoutes />
      </ThemeProvider>
  );
};

export default Main;
```


### Example usage of component

```js
import { Button } from 'native-pilot-ui';

const Example = () => {
  return (
    <Button onClick={() => console.log('button clicked')}>
      click here
    </Button>
  )
}

```


The uikit is type annotated so that you can easily find all the available options for themes.
Some of the Theme options are
- app
- drug
- church
