"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultProps = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const SvgSearch_1 = __importDefault(require("../icons/SvgSearch"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const colors_1 = require("../UikitUtils/colors");
const InputText_1 = __importDefault(require("../InputText/InputText"));
const SelectRowList_1 = __importDefault(require("./SelectRowList"));
const SelectTag_1 = require("./SelectTag");
exports.defaultProps = {
    // shd not be added here
    ...SelectTag_1.defaultProps,
    options: [],
    size: 16,
    color: 'primary',
    bold: false,
    searchPlaceHolder: 'Search',
};
const styles = react_native_1.StyleSheet.create({
    optionsContainer: {
        backgroundColor: colors_1.WHITE,
        maxHeight: 400,
    },
    inputStyle: {
        marginHorizontal: 8,
        marginVertical: 8,
    },
});
const SelectList = ({ labelKey, options, onChange, handleClose, size, color, bold, renderOption, valueKey, overrideStyleOptionsItem, maxHeight, resultItem, search, searchBy, multiselect, handleOnSelect, searchListTestId, searchPlaceHolder, showsVerticalScrollIndicator, }) => {
    const [optionContainerStyle, setOptionContainerStyle] = (0, react_1.useState)([styles.optionsContainer]);
    const [dropdownOptions, setDropdownOptions] = (0, react_1.useState)(options);
    const [searchValue, setSearchValue] = (0, react_1.useState)('');
    (0, react_1.useEffect)(() => {
        if (multiselect) {
            let filteredOptions = [];
            dropdownOptions.forEach(itemInit => {
                const filteredOption = options.filter(item => item[valueKey] === itemInit[valueKey]);
                filteredOptions = [...filteredOptions, ...filteredOption];
            });
            setDropdownOptions(filteredOptions);
        }
        else {
            setDropdownOptions(options);
        }
    }, [options]);
    (0, react_1.useEffect)(() => {
        setOptionContainerStyle([
            ...optionContainerStyle,
            {
                maxHeight,
            },
        ]);
    }, []);
    const filterCallback = (key, option, value) => `${option[key]}`.toLowerCase().trim().includes(value.toLowerCase().trim());
    const handleFilterSearch = (value) => {
        setSearchValue(value);
        if (value && typeof value === 'string') {
            let filteredResult = [];
            if (Array.isArray(searchBy)) {
                searchBy.forEach(searchByValue => {
                    const filteredResultItem = options.filter(option => filterCallback(searchByValue, option, value));
                    filteredResult = [...filteredResult, ...filteredResultItem];
                });
            }
            else {
                filteredResult = options.filter(option => filterCallback(labelKey, option, value));
            }
            setDropdownOptions(filteredResult);
        }
        else {
            setDropdownOptions(options);
        }
    };
    return (react_1.default.createElement(Flex_1.default, { overrideStyle: optionContainerStyle, testID: "SelectList" },
        search && (react_1.default.createElement(react_native_1.TouchableOpacity, { onFocus: e => e.stopPropagation() },
            react_1.default.createElement(InputText_1.default, { value: searchValue, onChange: handleFilterSearch, overrideStyle: styles.inputStyle, placeholder: searchPlaceHolder, actionLeft: () => react_1.default.createElement(SvgSearch_1.default, null) }))),
        react_1.default.createElement(react_native_1.FlatList, { keyExtractor: item => item[valueKey], extraData: { value: resultItem || '' }, showsVerticalScrollIndicator: showsVerticalScrollIndicator, showsHorizontalScrollIndicator: false, data: dropdownOptions, renderItem: ({ item, index }) => (react_1.default.createElement(SelectRowList_1.default, { overrideStyleOptionsItem: overrideStyleOptionsItem, valueKey: valueKey, renderOption: renderOption, bold: bold, size: size, color: color, labelKey: labelKey, options: dropdownOptions, onChange: onChange, handleClose: handleClose, item: item, index: index, searchBy: searchBy, multiselect: multiselect, handleOnSelect: handleOnSelect, searchListTestId: searchListTestId })) })));
};
SelectList.defaultProps = exports.defaultProps;
exports.default = SelectList;
