"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint global-require: "off" */
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const RenderMultiSelectOption_1 = __importDefault(require("./RenderMultiSelectOption"));
const SearchListLabel_1 = __importDefault(require("./SearchListLabel"));
const SelectList_1 = require("./SelectList");
const styles = react_native_1.StyleSheet.create({
    options: {
        paddingHorizontal: 16,
        paddingTop: 16,
        paddingBottom: 16,
    },
    optionArray: {
        paddingHorizontal: 16,
        paddingVertical: 4,
    },
});
const SelectRowList = ({ labelKey, onChange, handleClose, size, color, bold, renderOption, valueKey, item, overrideStyleOptionsItem, searchBy, multiselect, handleOnSelect, options, searchListTestId, index, }) => {
    const value = item[valueKey] || '';
    const label = item[labelKey] || '';
    const stringifyLabelKey = `${labelKey}`;
    const stringifyValueKey = `${valueKey}`;
    const handleSelectItem = (e) => {
        if (e) {
            e.stopPropagation();
            e.preventDefault();
        }
        if (!multiselect) {
            onChange(value, item);
        }
        handleClose();
    };
    const handleSelectFn = (val) => {
        if (typeof handleOnSelect === 'function') {
            handleOnSelect(val);
        }
    };
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: handleSelectItem, key: value, testID: "selectrowlist" },
        Array.isArray(searchBy) && (react_1.default.createElement(react_native_1.View, null, searchBy.map((searchOption, ind) => (react_1.default.createElement(SearchListLabel_1.default, { searchListTestId: searchListTestId, item: item, searchOption: searchOption, index: ind, size: size, bold: bold, overrideStyleOptionsItem: overrideStyleOptionsItem }))))),
        (() => {
            let rowResult;
            switch (multiselect) {
                case true:
                    rowResult = (react_1.default.createElement(RenderMultiSelectOption_1.default, { selectOptions: options, option: item, stringifyLabelKey: stringifyLabelKey, handleOnSelect: (val) => handleSelectFn(val), stringifyValueKey: stringifyValueKey, index: index }));
                    break;
                case undefined:
                case false:
                    if (typeof renderOption === 'function') {
                        rowResult = renderOption(item);
                    }
                    if (typeof renderOption !== 'function' &&
                        !Array.isArray(searchBy)) {
                        rowResult = (react_1.default.createElement(Flex_1.default, { overrideStyle: styles.options },
                            react_1.default.createElement(Text_1.default, { size: size, color: color, bold: bold, overrideStyle: overrideStyleOptionsItem }, label)));
                    }
                    break;
            }
            return rowResult;
        })()));
};
SelectRowList.defaultProps = SelectList_1.defaultProps;
exports.default = SelectRowList;
