/// <reference types="react" />
import { ThemeType } from '../UikitUtils/themeTypes';
export type DurationTypes = 'SHORT' | 'LONG';
export type ToastPositionType = 'TOP' | 'BOTTOM';
export type ToastBarType = 'BASIC' | 'SUCCESS' | 'ERROR' | 'INFO';
export type ToastParams = {
    message: string;
    duration?: DurationTypes;
    position?: ToastPositionType;
    type?: ToastBarType;
};
type ContextPropsType = {
    theme: ThemeType;
    showToast?: ({ message, duration, position, type }: ToastParams) => void;
    parentClicked?: boolean;
    setParentClicked?: (arg: boolean) => void;
};
export declare const handleShowToast: () => void;
declare const ThemeContext: import("react").Context<ContextPropsType>;
export { ThemeContext };
export default ThemeContext;
